#include <stdio.h>
#include <stdlib.h>

// ------------------------------------------------------------------------ Grupa A
char **napraviX( int A[][10], int N, int *nrX, int *nsX )
{
	int znam[ 8 ] = { 0 }, red, stup, i, kolikoZnamenki = 0, maxPojavljivanja = 0;
	char **X;
	
	for( red = 0; red < N; ++red )
		for( stup = 0; stup < N; ++stup )
			++znam[ A[ red ][ stup ] ];
			
	for( i = 1; i <= 7; ++i )
		if( znam[ i ] > maxPojavljivanja )
			maxPojavljivanja = znam[ i ];
	
	X = (char **) malloc( (maxPojavljivanja+1) * sizeof( char * ) );
	for( red = 0; red < maxPojavljivanja+1; ++red )
		X[ red ] = (char *) malloc( 7 * sizeof( char ) );
		
	stup = 0;
	for( i = 1; i <= 7; ++i )
	{
		stup = i-1;
		X[ 0 ][ stup ] = i + '0';
		for( red = 1; red <= maxPojavljivanja; ++red )
			if( red <= znam[ i ] )
				X[ red ][ stup ] = '*';
			else
				X[ red ][ stup ] = '.';
	}
	
	*nrX = maxPojavljivanja+1; *nsX = 7;
	return X;
}

int mainA( void )
{
	int A[ 10 ][ 10 ], N, red, stup, nrX, nsX;
	char **X;
	
	scanf( "%d", &N );
	for( red = 0; red < N; ++red )
		for( stup = 0; stup < N; ++stup )
			scanf( "%d", &A[ red ][ stup ] );
			
	X = napraviX( A, N, &nrX, &nsX );
	
	for( red = 0; red < nrX; ++red, printf( "\n" ) )
		for( stup = 0; stup < nsX; ++stup )
			printf( "%c", X[ red ][ stup ] );

	for( red = 0; red < nrX; ++red )
		free( X[ red ] );
	free( X );

	return 0;
}

// ------------------------------------------------------------------------ Grupa B
char **napraviY( int B[][20], int N, int *nrY, int *nsY )
{
	int znam[ 10 ] = { 0 }, red, stup, i, kolikoZnamenki = 0, maxPojavljivanja = 0;
	char **Y;
	
	for( red = 0; red < N; ++red )
		for( stup = 0; stup < N; ++stup )
			++znam[ B[ red ][ stup ] ];
			
	for( i = 5; i <= 9; ++i )
		if( znam[ i ] > maxPojavljivanja )
			maxPojavljivanja = znam[ i ];
	
	Y = (char **) malloc( 7 * sizeof( char * ) );
	for( red = 0; red < 7; ++red )
		Y[ red ] = (char *) malloc( (maxPojavljivanja+1) * sizeof( char ) );
		
	red = 0;
	for( i = 5; i <= 9; ++i )
	{
		red = i-5;
		Y[ red ][ maxPojavljivanja ] = i + '0';
		for( stup = 0; stup < maxPojavljivanja; ++stup )
			if( stup < maxPojavljivanja - znam[ i ] )
				Y[ red ][ stup ] = '-';
			else
				Y[ red ][ stup ] = 'x';
	}
	
	*nrY = 5; *nsY = maxPojavljivanja+1; 
	return Y;
}

int mainB( void )
{
	int B[ 20 ][ 20 ], N, red, stup, nrY, nsY;
	char **Y;
	
	scanf( "%d", &N );
	for( red = 0; red < N; ++red )
		for( stup = 0; stup < N; ++stup )
			scanf( "%d", &B[ red ][ stup ] );
			
	Y = napraviY( B, N, &nrY, &nsY );
	
	for( red = 0; red < nrY; ++red, printf( "\n" ) )
		for( stup = 0; stup < nsY; ++stup )
			printf( "%c", Y[ red ][ stup ] );

	for( red = 0; red < nrY; ++red )
		free( Y[ red ] );
	free( Y );

	return 0;
}

// ------------------------------------------------------------------------ Grupa C
char **napraviZ( char C[][30], int N, int *nrZ, int *nsZ )
{
	int slova[ 6 ] = { 0 }, red, stup, i, kolikoZnamenki = 0, maxPojavljivanja = 0;
	char **Z;
	
	for( red = 0; red < N; ++red )
		for( stup = 0; stup < N; ++stup )
			++slova[ C[ red ][ stup ] - 'A' ];
			
	for( i = 0; i < 6; ++i )
		if( slova[ i ] > maxPojavljivanja )
			maxPojavljivanja = slova[ i ];
	
	Z = (char **) malloc( (maxPojavljivanja+1) * sizeof( char * ) );
	for( red = 0; red < maxPojavljivanja+1; ++red )
		Z[ red ] = (char *) malloc( 6 * sizeof( char ) );
		
	stup = 0;
	for( i = 0; i < 6; ++i )
	{
		stup = i;
		Z[ maxPojavljivanja ][ stup ] = i + 'A';
		for( red = 0; red < maxPojavljivanja; ++red )
			if( red < maxPojavljivanja - slova[ i ] )
				Z[ red ][ stup ] = 'o';
			else
				Z[ red ][ stup ] = '#';
	}
	
	*nrZ = maxPojavljivanja+1; *nsZ = 6;
	return Z;
}

int mainC( void )
{
	int N, red, stup, nrZ, nsZ;
	char **Z, C[ 30 ][ 30 ];
	
	scanf( "%d", &N );
	for( red = 0; red < N; ++red )
		for( stup = 0; stup < N; ++stup )
			scanf( " %c", &C[ red ][ stup ] );
			
	Z = napraviZ( C, N, &nrZ, &nsZ );
	
	for( red = 0; red < nrZ; ++red, printf( "\n" ) )
		for( stup = 0; stup < nsZ; ++stup )
			printf( "%c", Z[ red ][ stup ] );

	for( red = 0; red < nrZ; ++red )
		free( Z[ red ] );
	free( Z );

	return 0;
}

// ------------------------------------------------------------------------ Grupa C
char **napraviW( char D[][40], int N, int *nrZ, int *nsZ )
{
	int slova[ 6 ] = { 0 }, red, stup, i, kolikoZnamenki = 0, maxPojavljivanja = 0;
	char **W;
	
	for( red = 0; red < N; ++red )
		for( stup = 0; stup < N; ++stup )
			++slova[ D[ red ][ stup ] - 'a' ];
			
	for( i = 0; i < 6; ++i )
		if( slova[ i ] > maxPojavljivanja )
			maxPojavljivanja = slova[ i ];
	
	W = (char **) malloc( 6 * sizeof( char * ) );
	for( red = 0; red < 6; ++red )
		W[ red ] = (char *) malloc( (maxPojavljivanja+1) * sizeof( char ) );
		
	red = 0;
	for( i = 0; i < 6; ++i )
	{
		red = i;
		W[ red ][ 0 ] = i + 'a';
		for( stup = 1; stup <= maxPojavljivanja; ++stup )
			if( stup <= slova[ i ] )
				W[ red ][ stup ] = '>';
			else
				W[ red ][ stup ] = ':';
	}
	
	*nrZ = 6; *nsZ = maxPojavljivanja+1; 
	return W;
}

int mainD( void )
{
	int N, red, stup, nrW, nsW;
	char **W, D[ 40 ][ 40 ];
	
	scanf( "%d", &N );
	for( red = 0; red < N; ++red )
		for( stup = 0; stup < N; ++stup )
			scanf( " %c", &D[ red ][ stup ] );
			
	W = napraviW( D, N, &nrW, &nsW );
	
	for( red = 0; red < nrW; ++red, printf( "\n" ) )
		for( stup = 0; stup < nsW; ++stup )
			printf( "%c", W[ red ][ stup ] );

	for( red = 0; red < nrW; ++red )
		free( W[ red ] );
	free( W );

	return 0;
}

// -------------------------------------------------------------------
int main( void )
{
	mainA();

	return 0;
}
